from os import path, makedirs

class test_process(object):

    def __init__(self, in_ids, out_ids, qcd_order, ew_order, qcd_me_part, threshold=1.0e-8, cms=2000.0):
        self._in_ids        = in_ids
        self._out_ids       = out_ids
	self._qcd_order	    = qcd_order
        self._ew_order      = ew_order
        self._qcd_me_part   = qcd_me_part
        self._threshold     = threshold
        self._cms           = cms

    def test_dir_name(self):
        return '_'.join(["sm"]+[str(id) for id in self._in_ids]+[str(id) for id in self._out_ids]+[str(self._qcd_me_part)])

    def __str__(self):
        return ' '.join([str(ide) for ide in self._in_ids])+' -> '+' '.join([str(ide) for ide in self._out_ids])


all_test_procs = []
# [in_flavours], [out_flavours], # of QCD Vertices, # of EW Vertices, NLO_QCD_Part


#============================================ Virtual processes ============================================#
##/all_test_procs.append(test_process([21, 21],[21, 21, 21],3,0,"V")) no good phasespace points
##/all_test_procs.append(test_process([21, 21],[21, 21],2,0,"V")) no good phasespace points
#all_test_procs.append(test_process([1, -1],[11, -11, 1, -1],2,2,"V"))
#all_test_procs.append(test_process([1, -1],[11, -11, 21, 21],2,2,"V"))
#all_test_procs.append(test_process([1, -1],[11, -11, 21],1,2,"V"))
#all_test_procs.append(test_process([1, -1],[11, -11, 25, 1, -1],2,3,"V"))
all_test_procs.append(test_process([1, -1],[11, -11],0,2,"V"))
#all_test_procs.append(test_process([1, -1],[11, 13, -11, -13],0,4,"V"))
#all_test_procs.append(test_process([1, -1],[1, -1],2,0,"V"))
#all_test_procs.append(test_process([1, -1],[21, 1, -1],3,0,"V"))
#all_test_procs.append(test_process([1, -1],[21, 21, 1, -1],4,0,"V"))
#all_test_procs.append(test_process([1, -1],[22, 1, -1],2,1,"V"))
#all_test_procs.append(test_process([1, -1],[22, 21],1,1,"V"))
#all_test_procs.append(test_process([1, -1],[22, 22, 22],0,3,"V"))
#all_test_procs.append(test_process([1, -1],[23, 21],1,1,"V"))
#all_test_procs.append(test_process([1, -1],[23, 23, 22],0,3,"V"))
#all_test_procs.append(test_process([1, -1],[23, 23, 23],0,3,"V"))
#all_test_procs.append(test_process([1, -1],[6, -6],2,0,"V"))
#all_test_procs.append(test_process([1, 21],[11, -11, 1],1,2,"V"))
#all_test_procs.append(test_process([1, 21],[11, -11, 21, 1],2,2,"V"))
#all_test_procs.append(test_process([1, -2],[23, -24, 22],0,3,"V")) 
#all_test_procs.append(test_process([2, -1],[-11, 12, 21],1,2,"V"))
#all_test_procs.append(test_process([2, -1],[-11, 12, 25, 21],1,3,"V"))
#all_test_procs.append(test_process([2, -1],[-11, 12, 3, -3],2,2,"V"))
#all_test_procs.append(test_process([2, -1],[-11, 12],0,2,"V"))
#all_test_procs.append(test_process([21, 21],[11, -11, 2, -2],2,2,"V"))
#all_test_procs.append(test_process([2, -1],[23, 23, 24],0,3,"V"))
#all_test_procs.append(test_process([2, -1],[23, 24, 21],1,2,"V"))
#all_test_procs.append(test_process([2, -1],[23, 24, 22],0,3,"V"))
#all_test_procs.append(test_process([2, -1],[24, 21, 21],2,1,"V"))
#all_test_procs.append(test_process([2, -1],[24, 21],1,1,"V"))
#all_test_procs.append(test_process([2, -1],[24, 22, 21],1,2,"V"))
#all_test_procs.append(test_process([2, -1],[24, 24, -24],0,3,"V"))
#all_test_procs.append(test_process([2, -1],[25, 24, 1, -1],2,2,"V"))
#all_test_procs.append(test_process([-2, 21],[11, -11, -2],1,2,"V"))
#all_test_procs.append(test_process([2, -2],[21, 21, 2, -2],4,0,"V"))
#all_test_procs.append(test_process([2, -2],[21, 21],2,0,"V"))
#all_test_procs.append(test_process([2, -2],[22, 22, 21],1,2,"V"))
#all_test_procs.append(test_process([2, -2],[22, 22],0,2,"V"))
#all_test_procs.append(test_process([2, -2],[2, -2],2,0,"V"))
#all_test_procs.append(test_process([2, -2],[23, 1, -1],2,1,"V"))
#all_test_procs.append(test_process([2, -2],[23, 22, 22],0,3,"V"))
#all_test_procs.append(test_process([2, -2],[23, 22],0,2,"V"))
#all_test_procs.append(test_process([2, -2],[23, 23, 21],1,2,"V"))
#all_test_procs.append(test_process([2, -2],[23, 23],0,2,"V"))
#all_test_procs.append(test_process([2, -2],[23, 24, -24],0,3,"V"))
#all_test_procs.append(test_process([2, -2],[24, -24, 21],1,2,"V"))
#all_test_procs.append(test_process([2, -2],[24, -24],0,2,"V"))
#all_test_procs.append(test_process([2, -2],[25, 23, 21],1,2,"V"))
#all_test_procs.append(test_process([2, -2],[25, 23],0,2,"V"))
#all_test_procs.append(test_process([2, -2],[3, -3],2,0,"V"))
#all_test_procs.append(test_process([2, -2],[6, -6, 21],3,0,"V"))
#all_test_procs.append(test_process([3, -3],[24, -24, 22],0,3,"V"))
#all_test_procs.append(test_process([3, -4],[13, -14, 21, 21],2,2,"V"))
#all_test_procs.append(test_process([3, -4],[13, -14, 21],1,2,"V"))
#all_test_procs.append(test_process([3, -4],[13, -14],0,2,"V"))
#all_test_procs.append(test_process([3, -4],[-24, 22, 22],0,3,"V"))
#all_test_procs.append(test_process([4, -3],[25, 24],0,2,"V"))
#all_test_procs.append(test_process([6, -6],[21, 21],2,0,"V"))
#all_test_procs.append(test_process([6, -6],[2, -2],2,0,"V"))

#============================================ loop-induced processes ============================================#
#all_test_procs.append(test_process([21, 21],[11, -11, 22],2,3,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[11, 13, -11, -13, 21],3,4,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[12, -12, 22, 21],3,3,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[13, 13, -13, -13],2,4,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[22, 21, 21],4,1,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[22, 21],3,1,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[22, 22],2,2,"LI",1.0e-6))
###all_test_procs.append(test_process([21, 21],[23, 23],2,2,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[24, -24],2,2,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[25, 23, 21],3,2,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[25, 23],2,2,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[25, 25, 21],3,2,"LI",1.0e-6))
#all_test_procs.append(test_process([21, 21],[25, 25],2,2,"LI",1.0e-6))


#### not yet implemented #####

	#/all_test_procs.append(test_process([2, -3],[4, -1],2,"B")) #OpenLoops not implemented?!

	##/all_test_procs.append(test_process([11, -11],[-24, 24],2,"B"))
	##/all_test_procs.append(test_process([23, 24],[22, 24],2,"B"))
	#/all_test_procs.append(test_process([25, 25],[25, 25],2,"B"))
	#/all_test_procs.append(test_process([25, 25],[25, 25, 25, 25],4,"B"))
	#/all_test_procs.append(test_process([25, 25],[23, 23],2,"B"))
	#/all_test_procs.append(test_process([25, 25],[24, -24],2,"B"))
	##/all_test_procs.append(test_process([23, -24],[11, -11, -24],3,"B"))
	##/all_test_procs.append(test_process([23, 23],[24, -24],2,"B"))
	##/all_test_procs.append(test_process([23, 23],[22, 22, 24, -24],4,"B"))
	##/all_test_procs.append(test_process([23, 23],[23, 23],2,"B"))
	#/all_test_procs.append(test_process([-15, 15],[24, -24],2,"B"))
	#/all_test_procs.append(test_process([-15, 15],[23, 23],2,"B"))
	#/all_test_procs.append(test_process([-15, 15],[23, 22],2,"B"))
	#/all_test_procs.append(test_process([-15, 15],[22, 22],2,"B"))
	#/all_test_procs.append(test_process([15, -15],[25, 25],2,"B"))
	#/all_test_procs.append(test_process([15, -15],[23, 23],2,"B"))
	#/all_test_procs.append(test_process([15, -15],[24, -24],2,"B"))
	#/all_test_procs.append(test_process([15, -15],[24, -24, 23],3,"B"))
	#/all_test_procs.append(test_process([15, 25],[15, 25, 25],3,"B"))
	##/all_test_procs.append(test_process([23, 24],[23, 24],2,"B"))
	##/all_test_procs.append(test_process([11, 23],[11, 23],2,"B"))
	##/all_test_procs.append(test_process([11, 24],[11, 24],2,"B"))	
	##/all_test_procs.append(test_process([-11, 11],[-11, 11],2,"B"))
	##/all_test_procs.append(test_process([-11, 11],[-13, 13],2,"B"))
	##/all_test_procs.append(test_process([-11, 11],[12, -12],2,"B"))
	##/all_test_procs.append(test_process([11, -12],[11, -12, 22, 22],4,"B"))
	#/all_test_procs.append(test_process([23, 25],[23, 25],2,"B"))
	##/all_test_procs.append(test_process([11, -13],[11, -13],2,"B"))
	##/all_test_procs.append(test_process([11, -11],[23, 23],2,"B"))
	##/all_test_procs.append(test_process([11, -11],[24, -24],2,"B"))
	##/all_test_procs.append(test_process([11, -11],[13, -13],2,"B"))
	##/all_test_procs.append(test_process([11, -11],[24, -24, 23],3,"B"))
	##/all_test_procs.append(test_process([11, -11],[15, -15],2,"B"))
	#/all_test_procs.append(test_process([11, -11],[15, -15, 25, 25],4,"B"))
	##/all_test_procs.append(test_process([11, -11],[15, -15, 23, 23],4,"B"))
	##/all_test_procs.append(test_process([11, -11],[15, -15, 22, 22],4,"B"))
	##/all_test_procs.append(test_process([11, -11],[11, -11],2,"B"))
	##/all_test_procs.append(test_process([11, -11],[12, -12],2,"B"))	
	##/all_test_procs.append(test_process([24, -24],[24, -24],2,"B"))
	##/all_test_procs.append(test_process([24, -24],[23, 23],2,"B"))
	##/all_test_procs.append(test_process([24, -24],[24, -24, 24, -24],4,"B"))

#============================================ Born processes ============================================#
##/all_test_procs.append(test_process([21, 21],[21, 21, 21],3,0,"B")) no good phasespace points
##/all_test_procs.append(test_process([21, 21],[21, 21],2,0,"B")) no good phasespace points
##/all_test_procs.append(test_process([1, -1],[1, -1],2,0,"B"))
##/all_test_procs.append(test_process([1, -1],[21, 1, -1],3,0,"B"))
##/all_test_procs.append(test_process([1, -1],[21, 21, 1, -1],4,0,"B"))
##/all_test_procs.append(test_process([2, -2],[21, 21],2,0,"B"))
##/all_test_procs.append(test_process([2, -2],[2, -2],2,0,"B"))
##/all_test_procs.append(test_process([2, -2],[21, 21, 2, -2],4,0,"B"))
##/all_test_procs.append(test_process([2, -2],[24, -24],0,2,"B"))
##/all_test_procs.append(test_process([2, -2],[23, 23],0,2,"B"))
##/all_test_procs.append(test_process([2, -2],[23, 22],0,2,"B"))
##/all_test_procs.append(test_process([2, -2],[22, 22],0,2,"B"))
##/all_test_procs.append(test_process([2, -2],[3, -3],2,0,"B"))
##/all_test_procs.append(test_process([2, -1],[4, -3],0,2,"B")) Virtual part OL does not work
##/all_test_procs.append(test_process([1, -1],[11, -11],0,2,"B"))
##/all_test_procs.append(test_process([1, -1],[11, -11, 21],1,2,"B"))
##/all_test_procs.append(test_process([1, 21],[11, -11, 1],1,2,"B"))
##/all_test_procs.append(test_process([-2, 21],[11, -11, -2],1,2,"B"))
##/all_test_procs.append(test_process([1, -1],[11, -11, 1, -1],2,2,"B"))
##/all_test_procs.append(test_process([1, -1],[11, -11, 21, 21],2,2,"B"))
##/all_test_procs.append(test_process([1, 21],[11, -11, 21, 1],2,2,"B"))
##/all_test_procs.append(test_process([21, 21],[11, -11, 2, -2],2,2,"B"))
##/all_test_procs.append(test_process([1, -1],[11, 13, -11, -13],0,4,"B"))
##/all_test_procs.append(test_process([2, -1],[-11, 12],0,2,"B"))
##/all_test_procs.append(test_process([3, -4],[13, -14],0,2,"B"))
##/all_test_procs.append(test_process([3, -4],[13, -14, 21],1,2,"B"))
##/all_test_procs.append(test_process([3, -4],[13, -14, 21, 21],2,2,"B"))
##/all_test_procs.append(test_process([2, -1],[-11, 12, 21],1,2,"B"))
##/all_test_procs.append(test_process([2, -1],[-11, 12, 3, -3],2,2,"B"))
##/all_test_procs.append(test_process([2, -1],[24, 21],1,1,"B"))
##/all_test_procs.append(test_process([1, -1],[22, 21],1,1,"B"))
##/all_test_procs.append(test_process([1, -1],[23, 21],1,1,"B"))
##/all_test_procs.append(test_process([2, -1],[23, 24, 21],1,2,"B"))
##/all_test_procs.append(test_process([2, -1],[24, 22, 21],1,2,"B"))
##/all_test_procs.append(test_process([2, -2],[24, -24, 21],1,2,"B"))
##/all_test_procs.append(test_process([2, -2],[23, 23, 21],1,2,"B"))
##/all_test_procs.append(test_process([2, -2],[22, 22, 21],1,2,"B"))
##/all_test_procs.append(test_process([1, -1],[22, 1, -1],2,1,"B"))
##/all_test_procs.append(test_process([2, -2],[23, 1, -1],2,1,"B"))
##/all_test_procs.append(test_process([2, -1],[24, 21, 21],2,1,"B"))
##/all_test_procs.append(test_process([3, -4],[-24, 22, 22],0,3,"B"))
##/all_test_procs.append(test_process([2, -2],[23, 22, 22],0,3,"B"))
##/all_test_procs.append(test_process([1, -2],[23, -24, 22],0,3,"B")) 
##/all_test_procs.append(test_process([3, -3],[24, -24, 22],0,3,"B"))
##/all_test_procs.append(test_process([2, -2],[23, 24, -24],0,3,"B"))
##/all_test_procs.append(test_process([2, -1],[23, 23, 24],0,3,"B"))
##/all_test_procs.append(test_process([1, -1],[23, 23, 22],0,3,"B"))
##/all_test_procs.append(test_process([1, -1],[22, 22, 22],0,3,"B"))
##/all_test_procs.append(test_process([2, -1],[24, 24, -24],0,3,"B"))
##/all_test_procs.append(test_process([1, -1],[23, 23, 23],0,3,"B"))
##/all_test_procs.append(test_process([2, -2],[25, 23],0,2,"B"))
##/all_test_procs.append(test_process([2, -2],[25, 23, 21],1,2,"B"))
##/all_test_procs.append(test_process([4, -3],[25, 24],0,2,"B"))
##/all_test_procs.append(test_process([2, -1],[25, 24, 1, -1],2,2,"B"))
##/all_test_procs.append(test_process([1, -1],[11, -11, 25, 1, -1],2,3,"B"))
##/all_test_procs.append(test_process([2, -1],[-11, 12, 25, 21],1,3,"B"))
##/all_test_procs.append(test_process([2, -1],[23, 24, 22],0,3,"B"))
##/all_test_procs.append(test_process([1, -1],[6, -6],2,0,"B"))
##/all_test_procs.append(test_process([2, -2],[6, -6, 21],3,0,"B"))
##/all_test_procs.append(test_process([6, -6],[21, 21],2,0,"B"))
##/all_test_procs.append(test_process([6, -6],[2, -2],2,0,"B"))
